Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.pattern
Class Pattern

    java.lang.Object
      net.sf.saxon.pattern.Pattern

All Implemented Interfaces:
  Serializable, SourceLocator, Container, PatternFinder

Direct Known Subclasses:
  IDPattern, KeyPattern, LocationPathPattern, NodeTestPattern, UnionPattern

    public abstract class Pattern

extends Object
implements PatternFinder, Serializable, Container

A Pattern represents the result of parsing an XSLT pattern string.
Patterns are created by calling the static method Pattern.make(string).
The pattern is used to test a particular node by calling match().

See Also:
  Serialized Form

Constructor Summary
`Pattern()`

Method Summary
`Pattern` | `analyze(StaticContext env, ItemType contextItemType)` Type-check the pattern.
`int` | `getColumnNumber()` Get the column number (always -1)
`double` | `getDefaultPriority()` Determine the default priority to use if this pattern appears as a match pattern for a template with no explicit priority attribute.
`int` | `getDependencies()` Get the dependencies of the pattern.
`Executable` | `getExecutable()` Get the Executable (representing a complete stylesheet or query) of which this Container forms part
`int` | `getFingerprint()` Determine the name fingerprint of nodes to which this pattern applies.
`int` | `getHostLanguage()` Get the host language (XSLT, XQuery, XPath) used to implement the code in this container
`int` | `getLineNumber()` Get the line number on which the pattern was defined
`LocationProvider` | `getLocationProvider()` Get the LocationProvider allowing location identifiers to be resolved.
`int` | `getNodeKind()` Determine the types of nodes to which this pattern applies.
`abstract NodeTest` | `getNodeTest()` Get a NodeTest that all the nodes matching this pattern must satisfy
`String` | `getPublicId()` Get the public ID (always null)
`String` | `getSystemId()` Get the system id of the entity in which the pattern occurred
`Iterator` | `iterateSubExpressions()` Iterate over the subexpressions within this pattern
`static Pattern` | `make(String pattern, StaticContext env, Executable exec)` Static method to make a Pattern by parsing a String.
`Expression` | `makeSearchExpression()` Make an expression whose effect is to select all the nodes that match this pattern in a given document.
`abstract boolean` | `matches(NodeInfo node, XPathContext context)` Determine whether this Pattern matches the given Node.
`void` | `promote(PromotionOffer offer)` Offer promotion for subexpressions within this pattern.
`boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`SequenceIterator` | `selectNodes(DocumentInfo doc, XPathContext context)` Select nodes in a document using this PatternFinder.
`void` | `setExecutable(Executable executable)`
`void` | `setLineNumber(int lineNumber)` Set the line number where the pattern occurred
`void` | `setOriginalText(String text)` Set the original text of the pattern for use in diagnostics
`void` | `setSystemId(String systemId)` Set the system ID where the pattern occurred
`Pattern` | `simplify(StaticContext env)` Simplify the pattern by applying any context-independent optimisations.
`String` | `toString()` Get the original pattern text

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Pattern

    public Pattern()

Method Detail

### make

    public static Pattern make(String pattern,
                               StaticContext env,
                               Executable exec)
                        throws XPathException

  Static method to make a Pattern by parsing a String.

  Parameters:
    `pattern` - The pattern text as a String
    `env` - An object defining the compile-time context for the expression
  Returns:
    The pattern object
  Throws:
    `XPathException`

### getExecutable

    public Executable getExecutable()

  Description copied from interface: `Container`
  Get the Executable (representing a complete stylesheet or query) of which this Container forms part

  Specified by:
    `getExecutable` in interface `Container`

### setExecutable

    public void setExecutable(Executable executable)

### getLocationProvider

    public LocationProvider getLocationProvider()

  Get the LocationProvider allowing location identifiers to be resolved.

  Specified by:
    `getLocationProvider` in interface `Container`

### setOriginalText

    public void setOriginalText(String text)

  Set the original text of the pattern for use in diagnostics

### simplify

    public Pattern simplify(StaticContext env)
                     throws XPathException

  Simplify the pattern by applying any context-independent optimisations. Default implementation does nothing.

  Returns:
    the optimised Pattern
  Throws:
    `XPathException`

### analyze

    public Pattern analyze(StaticContext env,
                           ItemType contextItemType)
                    throws XPathException

  Type-check the pattern. Default implementation does nothing. This is only needed for patterns that contain variable references or function calls.

  Returns:
    the optimised Pattern
  Throws:
    `XPathException`

### getDependencies

    public int getDependencies()

  Get the dependencies of the pattern. The only possible dependency for a pattern is on local variables. This is analyzed in those patterns where local variables may appear.

### iterateSubExpressions

    public Iterator iterateSubExpressions()

  Iterate over the subexpressions within this pattern

### promote

    public void promote(PromotionOffer offer)
                 throws XPathException

  Offer promotion for subexpressions within this pattern. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. By default the offer is not accepted - this is appropriate in the case of simple expressions such as constant values and variable references where promotion would give no performance advantage. This method is always called at compile time.

  Unlike the corresponding method on `Expression`, this method does not return anything: it can make internal changes to the pattern, but cannot return a different pattern. Only certain kinds of promotion are applicable within a pattern: specifically, promotions affecting local variable references within the pattern.

  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Throws:
    `XPathException` - if any error is detected

### setSystemId

    public void setSystemId(String systemId)

  Set the system ID where the pattern occurred

### setLineNumber

    public void setLineNumber(int lineNumber)

  Set the line number where the pattern occurred

### matches

    public abstract boolean matches(NodeInfo node,
                                    XPathContext context)
                             throws XPathException

  Determine whether this Pattern matches the given Node. This is the main external interface for matching patterns: it sets current() to the node being tested

  Parameters:
    `node` - The NodeInfo representing the Element or other node to be tested against the Pattern
    `context` - The dynamic context. Only relevant if the pattern uses variables, or contains calls on functions such as document() or key().
  Returns:
    true if the node matches the Pattern, false otherwise
  Throws:
    `XPathException`

### selectNodes

    public SequenceIterator selectNodes(DocumentInfo doc,
                                        XPathContext context)
                                 throws XPathException

  Select nodes in a document using this PatternFinder.

  Specified by:
    `selectNodes` in interface `PatternFinder`
  Parameters:
    `doc` - the document node at the root of a tree
    `context` - the dynamic evaluation context
  Returns:
    an iterator over the selected nodes in the document.
  Throws:
    `XPathException`

### makeSearchExpression

    public Expression makeSearchExpression()

  Make an expression whose effect is to select all the nodes that match this pattern in a given document. This expression takes the root of the tree (always a document node) as the context node; it takes into account all the constraints expressed by the pattern including the parent and ancestor nodes and the filters

### getNodeKind

    public int getNodeKind()

  Determine the types of nodes to which this pattern applies. Used for optimisation. For patterns that match nodes of several types, return Type.NODE

  Returns:
    the type of node matched by this pattern. e.g. Type.ELEMENT or Type.TEXT

### getFingerprint

    public int getFingerprint()

  Determine the name fingerprint of nodes to which this pattern applies. Used for optimisation.

  Returns:
    A fingerprint that the nodes must match, or -1 if it can match multiple fingerprints

### getNodeTest

    public abstract NodeTest getNodeTest()

  Get a NodeTest that all the nodes matching this pattern must satisfy

### getDefaultPriority

    public double getDefaultPriority()

  Determine the default priority to use if this pattern appears as a match pattern for a template with no explicit priority attribute.

### getSystemId

    public String getSystemId()

  Get the system id of the entity in which the pattern occurred

  Specified by:
    `getSystemId` in interface `SourceLocator`

### getLineNumber

    public int getLineNumber()

  Get the line number on which the pattern was defined

  Specified by:
    `getLineNumber` in interface `SourceLocator`

### getColumnNumber

    public int getColumnNumber()

  Get the column number (always -1)

  Specified by:
    `getColumnNumber` in interface `SourceLocator`

### getPublicId

    public String getPublicId()

  Get the public ID (always null)

  Specified by:
    `getPublicId` in interface `SourceLocator`

### toString

    public String toString()

  Get the original pattern text

  Overrides:
    `toString` in class `Object`

### getHostLanguage

    public int getHostLanguage()

  Get the host language (XSLT, XQuery, XPath) used to implement the code in this container

  Specified by:
    `getHostLanguage` in interface `Container`
  Returns:
    typically `Configuration.XSLT` or `Configuration.XQUERY`

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Description copied from interface: `Container`
  Replace one subexpression by a replacement subexpression

  Specified by:
    `replaceSubExpression` in interface `Container`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression was found

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.